/** Rill v0.0.479 https://www.npmjs.com/package/rill License: MIT*/
var Request, getUrl, httpReg, parseDates, parseURL;

parseURL = require("urllite");

parseDates = require("./util/parseDates");

httpReg = /^https?:\/\//i;


/*
 * Extract a parsed url from a request object.
#
 * @param {Object} req
 */

getUrl = function(req) {
  return parseURL(httpReg.test(req.url) ? req.url : (window.location.protocol.slice(1)) + "://" + (window.location.host) + req.url);
};

Request = (function() {
  function Request(req, basePath) {
    var err, ref, ref1, ref2, ref3, ref4;
    if (req == null) {
      req = {};
    }
    if (basePath == null) {
      basePath = "";
    }
    if (!(this instanceof Request)) {
      return new Request(req, basePath);
    }
    this.originalReq = req;
    this.url = getUrl(req);
    this.url.pathname = this.url.pathname.replace(basePath, "");
    this.headers = (ref = req.headers) != null ? ref : {};
    this.method = (ref1 = req.method) != null ? ref1 : "GET";
    this.subdomains = (ref2 = this.url.host) != null ? ref2.split('.').reverse().slice(2) : void 0;
    this.ip = ("127.0.0.1");
    try {
      this.query = JSON.parse(this.url.search.slice(1), parseDates);
    } catch (_error) {
      err = _error;
      this.query = {};
    }
  }


  /*
  	 * Trigger another request that will redirect the browser and send a location change on the server.
  	 * If "back" is the url then it will attempt to redirect the user back a url, otherwise the alt will be used.
  	#
  	 * @param {String} url
  	 * @param {String} alt
   */

  Request.prototype.redirect = function(url, alt) {
    var ref;
    if (url == null) {
      url = "back";
    }
    if (alt == null) {
      alt = "/";
    }
    if (url === "back") {
      url = (ref = this.headers["Referrer"]) != null ? ref : alt;
    }
    this.redirectURL = url;
    return this;
  };

  return Request;

})();

module.exports = Request;
