parseURL   = require("urllite")
parseDates = require("./util/parseDates")
httpReg    = /^https?:\/\//i

###
# Extract a parsed url from a request object.
#
# @param {Object} req
###
getUrl = (req)->
	parseURL(
		if httpReg.test(req.url) then req.url
		else (
			if process.browser then window.location.protocol.slice(1)
			else if req.socket.encrypted then "https"
			else "http"
		) + "://" + (
			if process.browser then window.location.host
			else req.headers.host
		) + req.url
	)

class Request
	constructor: (req = {}, basePath = "")->
		return new Request(req, basePath) unless this instanceof Request
		@originalReq  = req
		@url          = getUrl(req)
		@url.pathname = @url.pathname.replace(basePath, "")
		@headers      = req.headers ? {}
		@method       = req.method ? "GET"
		@subdomains   = @url.host?.split('.').reverse().slice(2)
		@ip           = (
			if process.browser then "127.0.0.1"
			else @headers['x-forwarded-for']?.split(',')[0] ? req.connection.remoteAddress
		)

		try @query = JSON.parse(@url.search.slice(1), parseDates)
		catch err then @query = {}

	###
	# Trigger another request that will redirect the browser and send a location change on the server.
	# If "back" is the url then it will attempt to redirect the user back a url, otherwise the alt will be used.
	#
	# @param {String} url
	# @param {String} alt
	###
	redirect: (url="back", alt="/")->
		url          = @headers["Referrer"] ? alt if url is "back"
		@redirectURL = url
		return this

module.exports = Request